# Table of Contents

- [Introduction](introduction.md)

- [Migrating from POSIX shells](migrating.md)

- [General rules](general.md)

- [Read–eval–print loop](repl.md)

- [Variables](variables/00-variables.md)

    - [String Variables](variables/01-strings.md)
    - [Array Variables](variables/02-arrays.md)
    - [Map Variables](variables/03-maps.md)
    - [Arithmetic Variables](variables/04-arithmetic.md)
    - [Exporting Variables](variables/05-exporting.md)
    - [Scopes](variables/06-scopes.md)
    - [Namespaces (colors, scopes and env vars)](variables/07-namespaces.md)

- [Expansions](expansions/00-expansions.md)

    - [Variable Expansions](expansions/01-variable.md)
    - [Process Expansions](expansions/02-process.md)
    - [Brace Expansions](expansions/03-brace.md)
    - [Arithmetic Expansions](expansions/04-arithmetic.md)
    - [Method Expansions](expansions/05-method.md)
    - [String Methods](expansions/06-stringmethods.md)
    - [Array Methods](expansions/07-arraymethods.md)
    - [Redox os specific](expansions/08-on_redox_os.md)

- [Slicing Syntax](slicing.md)

- [Control Flow](control/00-flow.md)

    - [Conditionals](control/01-conditionals.md)
    - [Loops](control/02-loops.md)
    - [Matches](control/03-matches.md)

- [Pipelines & Redirection](pipelines.md)

- [Functions](functions.md)

- [Script Executions](scripts/00-scripts.md)
    - [Sourcing](scripts/01-sourcing_another_file.md)
    - [Initialzing File](scripts/02-init_file.md)

- [Signal Handling](signals.md)

- [Job Control](jobs.md)

- [Builtin Commands](builtins.md)

- [Command History](history.md)
